# DNS File-Transfer
A file server for files over DNS TXT records

Mirror at: https://naclador.de/mosers/DNS_File-Transfer

## Requirements on server
- *Python3*
- *dnslib:* e.g. `pip3 install dnslib`

## Usage
First set up your domain to point to which ever server you're hosting this on.

Then run the python server:

`./server.py --domain domainname.com --directory /dir/of/tools`

It will only support a flat directory structure in /dir/of/tools

Strongly based on [Uninvited Guest by Pen Test Partners](https://github.com/pentestpartners/Uninvited-Guest)

## Documentation
### Download
1. TXT `$filename.count.$dnsserver` returns the number of parts the file is split into
2. TXT `$filename.$i.$dnsserver` returns the base64-encoded file part #*$i*

### Upload
- TXT `$content.$i-$id.$dnsserver` pushes a file part to the server
  - the whole domain MUST NOT be longer than 63 characters, split your file accordingly
  - since only alphanumerical characters are allowed, encode your file with base64
  - Count up *$i* so you don't get problems with caching (the server only used chronological order, so you can also use random numbers if you prefer that)
- The (base64-encoded) file is saved at *$directory*/*$id*.b64
